# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::VisualSearch::V1_0
  module Models
    #
    # Defines a list of offers from merchants that are related to the image.
    #
    class AggregateOffer < Offer

      include MsRestAzure


      def initialize
        @_type = "AggregateOffer"
      end

      attr_accessor :_type

      # @return [Array<Offer>] A list of offers from merchants that have
      # offerings related to the image.
      attr_accessor :offers


      #
      # Mapper for AggregateOffer class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AggregateOffer',
          type: {
            name: 'Composite',
            class_name: 'AggregateOffer',
            model_properties: {
              _type: {
                client_side_validation: true,
                required: true,
                serialized_name: '_type',
                type: {
                  name: 'String'
                }
              },
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              read_link: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'readLink',
                type: {
                  name: 'String'
                }
              },
              web_search_url: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'webSearchUrl',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              url: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'url',
                type: {
                  name: 'String'
                }
              },
              image: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'image',
                type: {
                  name: 'Composite',
                  class_name: 'ImageObject'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'description',
                type: {
                  name: 'String'
                }
              },
              alternate_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'alternateName',
                type: {
                  name: 'String'
                }
              },
              bing_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'bingId',
                type: {
                  name: 'String'
                }
              },
              seller: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'seller',
                type: {
                  name: 'Composite',
                  class_name: 'Organization'
                }
              },
              price: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'price',
                type: {
                  name: 'Double'
                }
              },
              price_currency: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'priceCurrency',
                default_value: 'USD',
                type: {
                  name: 'String'
                }
              },
              availability: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'availability',
                type: {
                  name: 'String'
                }
              },
              aggregate_rating: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'aggregateRating',
                type: {
                  name: 'Composite',
                  class_name: 'AggregateRating'
                }
              },
              last_updated: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'lastUpdated',
                type: {
                  name: 'String'
                }
              },
              offers: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'offers',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'OfferElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'Offer'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
